; Source created with Parsic Version 3.x

; at              : 14/08/02 12.30.09


; Project File    : C:\PROGRA~1\PARSIC\CONTAT~1\CONTLCD1.PIC

; Project Version : 1.1.27

; Created         : 14/03/99 21.14.00

; Last change     : 14/08/02 12.29.28

	PROCESSOR 16F628

	INCLUDE P16F628.INC

	RADIX DEC


	__IDLOCS H'0101'

	__CONFIG _CP_ALL & _PWRTE_ON & _WDT_ON & _BODEN_ON & _INTRC_OSC_NOCLKOUT & _LVP_OFF & _MCLRE_ON

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag


; Variable

LT1_FD	= 32	; located in Bank 0
LT2_FD	= 33	; located in Bank 0
LT3_FD	= 34	; located in Bank 0
LT4_FD	= 35	; located in Bank 0
TR1	= 36	; located in Bank 0
TR1_HI	= 37	; located in Bank 0
S0	= 38	; located in Bank 0
ZV1	= 39	; located in Bank 0
ZV1_HI	= 40	; located in Bank 0
ZV1_FD	= 41	; located in Bank 0
MF1	= 42	; located in Bank 0
MF1_HI	= 43	; located in Bank 0
TR2	= 44	; located in Bank 0
TR2_HI	= 45	; located in Bank 0
TR3	= 46	; located in Bank 0
TR3_HI	= 47	; located in Bank 0
ZV2	= 48	; located in Bank 0
ZV2_HI	= 49	; located in Bank 0
ZV2_FD	= 50	; located in Bank 0
S1	= 51	; located in Bank 0
TR4	= 52	; located in Bank 0
TR4_HI	= 53	; located in Bank 0
OS1_FD	= 54	; located in Bank 0
OS2_FD	= 55	; located in Bank 0
OS3_FD	= 56	; located in Bank 0
S2	= 57	; located in Bank 0
OS4_FD	= 58	; located in Bank 0
TR5	= 59	; located in Bank 0
TR5_HI	= 60	; located in Bank 0
OS5_FD	= 61	; located in Bank 0
RAM	= 62	; located in Bank 0
SYS_TMP1	= 112	; located in Bank 0, 1, 2, 3
SYS_TMP2	= 113	; located in Bank 0, 1, 2, 3
SYS_TMP3	= 114	; located in Bank 0, 1, 2, 3
SYS_TMP4	= 115	; located in Bank 0, 1, 2, 3
SYS_TMP5	= 116	; located in Bank 0, 1, 2, 3
SYS_TMP6	= 117	; located in Bank 0, 1, 2, 3
SYS_TMP9	= 118	; located in Bank 0, 1, 2, 3
SYS_TMP10	= 119	; located in Bank 0, 1, 2, 3
SYS_WSAV	= 120	; located in Bank 0, 1, 2, 3
SYS_SSAV	= 121	; located in Bank 0, 1, 2, 3

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	CLRF STATUS	; switch to RAM-Bank 0
	GOTO SYS_INIT
	NOP
	NOP

;****************************************
;Interrupt-Adress
;****************************************

	MOVWF SYS_WSAV	; save register
	SWAPF STATUS,W
	CLRF STATUS	; bank 0
	MOVWF SYS_SSAV

	BCF INTCON,T0IF	; Interrupt quitieren

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	INCFSZ TR1,F
	GOTO SYS_INT_LABEL_0
	INCF TR1_HI,F

SYS_INT_LABEL_0
	INCFSZ MF1,F
	GOTO SYS_INT_LABEL_1
	INCF MF1_HI,F

SYS_INT_LABEL_1
	INCFSZ TR2,F
	GOTO SYS_INT_LABEL_2
	INCF TR2_HI,F

SYS_INT_LABEL_2
	INCFSZ TR3,F
	GOTO SYS_INT_LABEL_3
	INCF TR3_HI,F

SYS_INT_LABEL_3
	INCFSZ TR4,F
	GOTO SYS_INT_LABEL_4
	INCF TR4_HI,F

SYS_INT_LABEL_4
	INCFSZ TR5,F
	GOTO SYS_INT_LABEL_5
	INCF TR5_HI,F

SYS_INT_LABEL_5

EXITINT

	SWAPF SYS_SSAV,W	; Register zurck
	MOVWF STATUS
	SWAPF SYS_WSAV,F
	SWAPF SYS_WSAV,W

	RETFIE	; RETurn From Interrupt and Enable GIE


;****************************************
; Subroutines
;****************************************

;***************************************************
; Subroutines for LB1
;***************************************************

LCD_LB1_INIT
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTB,4	; ir-register
LCD_LB1_L1
	CALL LCD_LB1_OUT4
	CLRWDT
	DECFSZ SYS_TMP1,F
	GOTO LCD_LB1_L1

	MOVFW PORTB
	ANDLW H'F0'
	IORLW B'0011'	; Function Set
	MOVWF PORTB

	BSF PORTB,5	; write
	BCF PORTB,5

	BSF SYS_TMP1,5	; wait
LCD_LB1_L2
	CALL LCD_LB1_OUT4
	CLRWDT
	DECFSZ SYS_TMP1,F
	GOTO LCD_LB1_L2

	BSF PORTB,5	; write
	BCF PORTB,5

	CALL LCD_LB1_OUT4

	BSF PORTB,5	; write
	BCF PORTB,5

	CALL LCD_LB1_OUT4

	BCF PORTB,0	; 4-Bit Interface

	BSF PORTB,5	; write
	BCF PORTB,5

	CALL LCD_LB1_OUT4

	MOVLW B'00101000'	; Function Set 4-Bit,2-Lines
	CALL LCD_LB1_OUT

	MOVLW B'00001100'	; Display on, Cursor off, Blink off
	CALL LCD_LB1_OUT

	MOVLW B'00000110'	; Entrymode set
	CALL LCD_LB1_OUT

LCD_LB1_CLR
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTB,4	; ir-register
	MOVLW B'00000001'	; Display clear
	CALL LCD_LB1_OUT

	BSF SYS_TMP1,5	; wait
LCD_LB1_L3
	CALL LCD_LB1_OUT4
	CLRWDT
	DECFSZ SYS_TMP1,F
	GOTO LCD_LB1_L3
	GOTO LCD_LB1_OUT4

;***************************************************

LCD_LB1_GOTOXY
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTB,4	; ir-register
	MOVLW H'40'
	BTFSC SYS_TMP2,0	; Ypos
	ADDWF SYS_TMP1,F
	BSF SYS_TMP1,7	; select dd-ram
	GOTO LCD_LB1_OUT1

;***************************************************

LCD_LB1_WRITESTR
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF PORTB,4	; dd-ram
LCD_LB1_WRITESTR1
	CALL LCD_LB1_CHAROUT
	BSF INTCON,GIE
	ANDLW H'FF'	; last is zero
	BTFSC STATUS,ZERO
	RETURN

	MOVWF SYS_TMP1
	CLRWDT
	CALL LCD_LB1_OUT1
	INCFSZ SYS_TMP4,F	; next char
	GOTO LCD_LB1_WRITESTR1
	INCF SYS_TMP5,F	; next page
	GOTO LCD_LB1_WRITESTR1

LCD_LB1_CHAROUT
	BCF INTCON,GIE
	MOVFW SYS_TMP5
	MOVWF PCLATH
	MOVFW SYS_TMP4
	MOVWF PCL

;***************************************************

LCD_LB1_DEZO10000

	MOVLW LOW 10000
	MOVWF SYS_TMP1
	MOVLW HIGH 10000
	MOVWF SYS_TMP2

	CALL LCD_LB1_CONVERTDEZ
	MOVF SYS_TMP9,F
	BTFSS STATUS,ZERO
	GOTO LCD_LB1_DEZO1000
	CALL LCD_LB1_CHECKNULL

LCD_LB1_DEZO1000

	MOVLW LOW 1000
	MOVWF SYS_TMP1
	MOVLW HIGH 1000
	MOVWF SYS_TMP2

	CALL LCD_LB1_CONVERTDEZ
	MOVF SYS_TMP9,F
	BTFSS STATUS,ZERO
	GOTO LCD_LB1_DEZO100
	CALL LCD_LB1_CHECKNULL

LCD_LB1_DEZO100

	MOVLW LOW 100
	MOVWF SYS_TMP1
	CLRF SYS_TMP2

	CALL LCD_LB1_CONVERTDEZ
	MOVF SYS_TMP9,F
	BTFSS STATUS,ZERO
	GOTO LCD_LB1_DEZO10
	CALL LCD_LB1_CHECKNULL

LCD_LB1_DEZO10

	MOVLW LOW 10
	MOVWF SYS_TMP1
	CLRF SYS_TMP2

	CALL LCD_LB1_CONVERTDEZ
	MOVF SYS_TMP9,F
	BTFSS STATUS,ZERO
	GOTO LCD_LB1_DEZO1
	CALL LCD_LB1_CHECKNULL

LCD_LB1_DEZO1
	MOVLW 48
	ADDWF SYS_TMP4,W
	GOTO LCD_LB1_WRITECHAR

;***************************************************

LCD_LB1_CONVERTDEZ
	MOVF SYS_TMP9,F
	BTFSS STATUS,ZERO
	DECF SYS_TMP9,F
	CLRF SYS_TMP6
LCD_LB1_CONVERTDEZ2
	INCF SYS_TMP6,F

	MOVFW SYS_TMP1
	SUBWF SYS_TMP4,F

	MOVFW SYS_TMP2
	BTFSS STATUS,CARRY
	INCFSZ SYS_TMP2,W
	SUBWF SYS_TMP5,F
	BTFSC STATUS,CARRY
	GOTO LCD_LB1_CONVERTDEZ2

	MOVFW SYS_TMP2
	ADDWF SYS_TMP5,F
	MOVFW SYS_TMP1
	ADDWF SYS_TMP4,F
	BTFSC STATUS,CARRY
	INCF SYS_TMP5,F

	DECF SYS_TMP6,W
	BTFSS STATUS,ZERO
	BSF SYS_TMP10,0
	RETURN

;***************************************************

LCD_LB1_CONVERTHEX
	ANDLW 15
	MOVWF SYS_TMP1
	MOVLW 48
	ADDWF SYS_TMP1,F
	MOVLW 58
	SUBWF SYS_TMP1,W
	BTFSS STATUS,CARRY
	GOTO $+3
	MOVLW 7
	ADDWF SYS_TMP1,F
	MOVFW SYS_TMP1

;***************************************************

LCD_LB1_WRITECHAR
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF PORTB,4	; dd-ram

;***************************************************

LCD_LB1_OUT
	MOVWF SYS_TMP1	; store
LCD_LB1_OUT1
	CLRF SYS_TMP3	; LCDWriteStr (first nibble)
LCD_LB1_OUT2
	SWAPF SYS_TMP1,W	;high nibble
LCD_LB1_OUT3
	ANDLW H'0F'	; mask
	MOVWF SYS_TMP2	; store
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW PORTB	; load port
	ANDLW H'F0'	; mask
	IORWF SYS_TMP2,W	; add cmd
	MOVWF PORTB	; out

	BSF PORTB,5	; E high
	BCF PORTB,5	; E low

	BTFSC SYS_TMP3,3	; ready ?
	GOTO LCD_LB1_OUT4	; yes
	BSF SYS_TMP3,3	; second nibble
	MOVFW SYS_TMP1
	GOTO LCD_LB1_OUT3	; next nibble

LCD_LB1_OUT4
LCD_LB1_OUTV
	DECFSZ SYS_TMP3,F
	GOTO LCD_LB1_OUTV
	RETURN

;***************************************************

LCD_LB1_CHECKNULL
	BTFSS STATUS,ZERO
	DECF SYS_TMP9,F
	MOVWF SYS_TMP1
	BTFSS STATUS,ZERO
	BSF SYS_TMP10,0
	MOVLW 48
	BTFSC SYS_TMP10,0
	ADDWF SYS_TMP1,f
	MOVLW 32
	BTFSS SYS_TMP10,0
	ADDWF SYS_TMP1,F
	MOVFW SYS_TMP1
	GOTO LCD_LB1_WRITECHAR
; 00D7

;****************************************
;Initialisierung
;****************************************


SYS_INIT

	MOVLW B'00100000'
	MOVWF INTCON

; Ausgangs-Pegel setzen, bevor die Richtung gesetzt wird

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVLW B'00000000'
	MOVWF PORTA

	MOVLW B'00000000'
	MOVWF PORTB

	MOVLW 143
	BSF STATUS,RP0	; Bank 1
	MOVWF OPTION_REG


; Richtung setzen

	MOVLW B'11111111'
	MOVWF TRISA

	MOVLW B'00000000'
	MOVWF TRISB

	BCF STATUS,RP0	; Bank 0
	MOVLW 7	; Comparators off
	MOVWF CMCON
; init vars


; Clear RAM

	BCF STATUS,IRP
	MOVLW 32
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	BTFSS FSR,7
	GOTO CR1
	BSF FSR,5
CR2
	CLRF INDF
	INCF FSR,F
	MOVLW H'F0'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR2
	BSF STATUS,IRP
	MOVLW 32
	MOVWF FSR
CR3
	CLRF INDF
	INCF FSR,F
	MOVLW H'50'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR3


;***************************************************
; Init LCD -> LB1
;***************************************************

	CALL LCD_LB1_INIT

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	CLRF TMR0
	BCF INTCON,T0IF
	BSF INTCON,GIE	; Interrupt freigeben

;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

	CLRWDT

;***************************************************
; LCD -> LT1
;***************************************************

; test of positiv edge

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC LT1_FD,0
	GOTO LABEL_LT1_SETFD
	BTFSS S0,0
	GOTO LABEL_LT1_SETFD


	MOVLW 16
	MOVWF SYS_TMP1
	MOVLW 0
	MOVWF SYS_TMP2

	CALL LCD_LB1_GOTOXY

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW ZV1
	MOVWF SYS_TMP4
	MOVFW ZV1_HI
	MOVWF SYS_TMP5

	BSF SYS_TMP10,0
	MOVLW 2
	MOVWF SYS_TMP9
	CALL LCD_LB1_DEZO10000
LABEL_LT1_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S0,0
	GOTO LABEL_LT1_SETFD2
	BSF LT1_FD,0
	GOTO LABEL_LT1_END
LABEL_LT1_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT1_FD,0
LABEL_LT1_END

;***************************************************
; LCD -> LT2
;***************************************************

; test of positiv edge

	BTFSC LT2_FD,0
	GOTO LABEL_LT2_SETFD
	BTFSS S0,0
	GOTO LABEL_LT2_SETFD


	MOVLW 16
	MOVWF SYS_TMP1
	MOVLW 1
	MOVWF SYS_TMP2

	CALL LCD_LB1_GOTOXY

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW ZV2
	MOVWF SYS_TMP4
	MOVFW ZV2_HI
	MOVWF SYS_TMP5

	BSF SYS_TMP10,0
	MOVLW 2
	MOVWF SYS_TMP9
	CALL LCD_LB1_DEZO10000
LABEL_LT2_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S0,0
	GOTO LABEL_LT2_SETFD2
	BSF LT2_FD,0
	GOTO LABEL_LT2_END
LABEL_LT2_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT2_FD,0
LABEL_LT2_END

;***************************************************
; LCD -> LT3
;***************************************************

; test of positiv edge

	BTFSC LT3_FD,0
	GOTO LABEL_LT3_SETFD
	BTFSS S0,0
	GOTO LABEL_LT3_SETFD


	MOVLW 0
	MOVWF SYS_TMP1
	MOVLW 0
	MOVWF SYS_TMP2

	CALL LCD_LB1_GOTOXY

	MOVLW LOW TAB_LT3
	MOVWF SYS_TMP4
	MOVLW HIGH TAB_LT3
	MOVWF SYS_TMP5


	CALL LCD_LB1_WRITESTR

LABEL_LT3_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S0,0
	GOTO LABEL_LT3_SETFD2
	BSF LT3_FD,0
	GOTO LABEL_LT3_END
LABEL_LT3_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT3_FD,0
LABEL_LT3_END

;***************************************************
; LCD -> LT4
;***************************************************

; test of positiv edge

	BTFSC LT4_FD,0
	GOTO LABEL_LT4_SETFD
	BTFSS S0,0
	GOTO LABEL_LT4_SETFD


	MOVLW 0
	MOVWF SYS_TMP1
	MOVLW 1
	MOVWF SYS_TMP2

	CALL LCD_LB1_GOTOXY

	MOVLW LOW TAB_LT4
	MOVWF SYS_TMP4
	MOVLW HIGH TAB_LT4
	MOVWF SYS_TMP5


	CALL LCD_LB1_WRITESTR

LABEL_LT4_SETFD

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S0,0
	GOTO LABEL_LT4_SETFD2
	BSF LT4_FD,0
	GOTO LABEL_LT4_END
LABEL_LT4_SETFD2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF LT4_FD,0
LABEL_LT4_END

;***************************************************
; Timer -> TR1
;***************************************************

	MOVLW 0	; Test auf >=
	SUBWF TR1_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR1_CHECK
	MOVLW 20
	SUBWF TR1,W	;F-W -> W
LABEL_TR1_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR1_ENDE

LABEL_TR1_RESET
	MOVLW 0	; Test auf >=
	SUBWF TR1_HI,F	;F-W -> F
	MOVLW 20
	SUBWF TR1,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR1_HI,F

LABEL_TR1_SET	; toggel output
	BTFSC S0,0
	GOTO LABEL_TR1_CLR
	BSF S0,0
	GOTO LABEL_TR1_ENDE
LABEL_TR1_CLR
	BCF S0,0
LABEL_TR1_ENDE

;***************************************************
; Zhler -> ZV1
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS PORTA,0	; Reset ?
	GOTO LABEL_ZV1_COUNT
	CLRF ZV1
	CLRF ZV1_HI
	GOTO LABEL_ZV1_SETOUT

LABEL_ZV1_COUNT

; Test auf positive Flanke

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S0,5
	GOTO LABEL_ZV1_SETFD
	BTFSC ZV1_FD,0
	GOTO LABEL_ZV1_SETFD

	BSF ZV1_FD,0


	BTFSC PORTA,2	; Vorwrts oder Rckwrts ?
	GOTO LABEL_ZV1_BACKWARD

	INCFSZ ZV1,F
	GOTO LABEL_ZV1_SETOUT
	INCF ZV1_HI,F
	GOTO LABEL_ZV1_SETOUT

LABEL_ZV1_BACKWARD
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	DECF ZV1,F
	INCFSZ ZV1,W
	GOTO LABEL_ZV1_SETOUT
	DECF ZV1_HI,F

LABEL_ZV1_SETOUT


LABEL_ZV1_SETFD

; Test auf negative Flanke

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S0,5
	GOTO LABEL_ZV1_EXIT
	BCF ZV1_FD,0

LABEL_ZV1_EXIT

;***************************************************
; UND - Gatter -> LG1
;***************************************************

LABEL_LG1_1
	BTFSS S0,4
	GOTO LABEL_LG1_FALSE
LABEL_LG1_2
	BTFSS S0,2
	GOTO LABEL_LG1_FALSE

LABEL_LG1_TRUE
	BSF S0,6
	GOTO LABEL_LG1_ENDE
LABEL_LG1_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S0,6
LABEL_LG1_ENDE
;***************************************************
; Anzug-Verzgerung -> MF1
;***************************************************

	BTFSC S0,3	; Eingang auf High ?
	GOTO LABEL_MF1_CHKTIME	; Ja

; RESET

	CLRF MF1
	CLRF MF1_HI
	BCF S0,2
	GOTO LABEL_MF1_EXIT	; raus

LABEL_MF1_CHKTIME

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S0,2	; Ausgang schon auf High ?
	GOTO LABEL_MF1_EXIT	; Ja

	MOVLW 76
	SUBWF MF1_HI,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF1_EXIT

	MOVLW 75
	SUBWF MF1,W
	BTFSS STATUS,CARRY
	GOTO LABEL_MF1_EXIT

	BSF S0,2
LABEL_MF1_EXIT

;***************************************************
; Timer -> TR2
;***************************************************

	MOVLW 0	; Test auf >=
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	SUBWF TR2_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR2_CHECK
	MOVLW 20
	SUBWF TR2,W	;F-W -> W
LABEL_TR2_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR2_ENDE

LABEL_TR2_RESET
	MOVLW 0	; Test auf >=
	SUBWF TR2_HI,F	;F-W -> F
	MOVLW 20
	SUBWF TR2,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR2_HI,F

LABEL_TR2_SET	; toggel output
	BTFSC S0,4
	GOTO LABEL_TR2_CLR
	BSF S0,4
	GOTO LABEL_TR2_ENDE
LABEL_TR2_CLR
	BCF S0,4
LABEL_TR2_ENDE

;***************************************************
; Timer -> TR3
;***************************************************

	MOVLW 7	; Test auf >=
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	SUBWF TR3_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR3_CHECK
	MOVLW 161
	SUBWF TR3,W	;F-W -> W
LABEL_TR3_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR3_ENDE

LABEL_TR3_RESET
	MOVLW 7	; Test auf >=
	SUBWF TR3_HI,F	;F-W -> F
	MOVLW 161
	SUBWF TR3,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR3_HI,F

LABEL_TR3_SET	; toggel output
	BTFSC S0,1
	GOTO LABEL_TR3_CLR
	BSF S0,1
	GOTO LABEL_TR3_ENDE
LABEL_TR3_CLR
	BCF S0,1
LABEL_TR3_ENDE

;***************************************************
; UND - Gatter -> LG2
;***************************************************

LABEL_LG2_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S0,1
	GOTO LABEL_LG2_FALSE
LABEL_LG2_2
	BTFSC S0,2
	GOTO LABEL_LG2_FALSE
LABEL_LG2_3
	BTFSS S0,3
	GOTO LABEL_LG2_FALSE

LABEL_LG2_TRUE
	BSF S0,7
	GOTO LABEL_LG2_ENDE
LABEL_LG2_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S0,7
LABEL_LG2_ENDE
;***************************************************
; Limiter -> LM1
;***************************************************

	MOVFW ZV1
	MOVWF ZV1
	MOVFW ZV1_HI
	MOVWF ZV1_HI

	MOVLW HIGH 9999
	SUBWF ZV1_HI,W
	BTFSS STATUS,ZERO
	GOTO LABEL_LM1_CHECK1
	MOVLW LOW 9999
	SUBWF ZV1,W
LABEL_LM1_CHECK1
	BTFSS STATUS,CARRY
	GOTO LABEL_LM1_EXIT
	BTFSC STATUS,ZERO
	GOTO LABEL_LM1_EXIT
	MOVLW LOW 9999
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVWF ZV1
	MOVLW HIGH 9999
	MOVWF ZV1_HI
LABEL_LM1_EXIT

;***************************************************
; ODER - Gatter -> LG3
;***************************************************

LABEL_LG3_1
	BTFSC S0,6
	GOTO LABEL_LG3_TRUE
LABEL_LG3_2
	BTFSC S0,7
	GOTO LABEL_LG3_TRUE

LABEL_LG3_FALSE
	BCF S0,5
	GOTO LABEL_LG3_ENDE
LABEL_LG3_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF S0,5
LABEL_LG3_ENDE
;***************************************************
; Zhler -> ZV2
;***************************************************

	BTFSS S2,2	; Reset ?
	GOTO LABEL_ZV2_COUNT
	CLRF ZV2
	CLRF ZV2_HI
	GOTO LABEL_ZV2_SETOUT

LABEL_ZV2_COUNT

; Test auf positive Flanke

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S1,3
	GOTO LABEL_ZV2_SETFD
	BTFSC ZV2_FD,0
	GOTO LABEL_ZV2_SETFD

	BSF ZV2_FD,0


	BTFSC PORTA,7	; Vorwrts oder Rckwrts ?
	GOTO LABEL_ZV2_BACKWARD

	INCFSZ ZV2,F
	GOTO LABEL_ZV2_SETOUT
	INCF ZV2_HI,F
	GOTO LABEL_ZV2_SETOUT

LABEL_ZV2_BACKWARD
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	DECF ZV2,F
	INCFSZ ZV2,W
	GOTO LABEL_ZV2_SETOUT
	DECF ZV2_HI,F

LABEL_ZV2_SETOUT


LABEL_ZV2_SETFD

; Test auf negative Flanke

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S1,3
	GOTO LABEL_ZV2_EXIT
	BCF ZV2_FD,0

LABEL_ZV2_EXIT

;***************************************************
; RS-FLIP-FLOP -> RS1
;***************************************************

	BTFSC S1,7
	GOTO LABEL_RS1_RESET
	BTFSS S1,2
	GOTO LABEL_RS1_ENDE
	BSF S1,1	; Ausgang setzen
	GOTO LABEL_RS1_ENDE
LABEL_RS1_RESET
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S1,1	; Ausgang zurcksetzen
LABEL_RS1_ENDE

;***************************************************
; UND - Gatter -> LG4
;***************************************************

LABEL_LG4_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S1,0
	GOTO LABEL_LG4_FALSE
LABEL_LG4_2
	BTFSS S1,1
	GOTO LABEL_LG4_FALSE
LABEL_LG4_3
	BTFSS PORTA,4
	GOTO LABEL_LG4_FALSE

LABEL_LG4_TRUE
	BSF S1,4
	GOTO LABEL_LG4_ENDE
LABEL_LG4_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S1,4
LABEL_LG4_ENDE
;***************************************************
; Timer -> TR4
;***************************************************

	MOVLW 7	; Test auf >=
	SUBWF TR4_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR4_CHECK
	MOVLW 161
	SUBWF TR4,W	;F-W -> W
LABEL_TR4_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR4_ENDE

LABEL_TR4_RESET
	MOVLW 7	; Test auf >=
	SUBWF TR4_HI,F	;F-W -> F
	MOVLW 161
	SUBWF TR4,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR4_HI,F

LABEL_TR4_SET	; toggel output
	BTFSC S1,0
	GOTO LABEL_TR4_CLR
	BSF S1,0
	GOTO LABEL_TR4_ENDE
LABEL_TR4_CLR
	BCF S1,0
LABEL_TR4_ENDE

;***************************************************
; One Shot -> OS1
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS PORTA,3
	GOTO LABEL_OS1_1
	BTFSC OS1_FD,0
	GOTO LABEL_OS1_1
	BSF OS1_FD,0
	BSF S1,2
	GOTO LABEL_OS1_2
LABEL_OS1_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S1,2
	BTFSC PORTA,3
	GOTO LABEL_OS1_2
	BCF OS1_FD,0
LABEL_OS1_2
;***************************************************
; ODER - Gatter -> LG5
;***************************************************

LABEL_LG5_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S1,4
	GOTO LABEL_LG5_TRUE
LABEL_LG5_2
	BTFSC S1,5
	GOTO LABEL_LG5_TRUE

LABEL_LG5_FALSE
	BCF S1,3
	GOTO LABEL_LG5_ENDE
LABEL_LG5_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF S1,3
LABEL_LG5_ENDE
;***************************************************
; One Shot -> OS2
;***************************************************


	BTFSS PORTA,5
	GOTO LABEL_OS2_1
	BTFSC OS2_FD,0
	GOTO LABEL_OS2_1
	BSF OS2_FD,0
	BSF S1,5
	GOTO LABEL_OS2_2
LABEL_OS2_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S1,5
	BTFSC PORTA,5
	GOTO LABEL_OS2_2
	BCF OS2_FD,0
LABEL_OS2_2
;***************************************************
; Limiter -> LM2
;***************************************************

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVFW ZV2
	MOVWF ZV2
	MOVFW ZV2_HI
	MOVWF ZV2_HI

	MOVLW HIGH 9999
	SUBWF ZV2_HI,W
	BTFSS STATUS,ZERO
	GOTO LABEL_LM2_CHECK1
	MOVLW LOW 9999
	SUBWF ZV2,W
LABEL_LM2_CHECK1
	BTFSS STATUS,CARRY
	GOTO LABEL_LM2_EXIT
	BTFSC STATUS,ZERO
	GOTO LABEL_LM2_EXIT
	MOVLW LOW 9999
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVWF ZV2
	MOVLW HIGH 9999
	MOVWF ZV2_HI
LABEL_LM2_EXIT

;***************************************************
; One Shot -> OS3
;***************************************************


	BTFSS PORTA,6
	GOTO LABEL_OS3_1
	BTFSC OS3_FD,0
	GOTO LABEL_OS3_1
	BSF OS3_FD,0
	BSF S1,6
	GOTO LABEL_OS3_2
LABEL_OS3_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S1,6
	BTFSC PORTA,6
	GOTO LABEL_OS3_2
	BCF OS3_FD,0
LABEL_OS3_2
;***************************************************
; ODER - Gatter -> LG6
;***************************************************

LABEL_LG6_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC PORTA,1
	GOTO LABEL_LG6_TRUE
LABEL_LG6_2
	BTFSC PORTA,2
	GOTO LABEL_LG6_TRUE

LABEL_LG6_FALSE
	BCF S0,3
	GOTO LABEL_LG6_ENDE
LABEL_LG6_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF S0,3
LABEL_LG6_ENDE
;***************************************************
; Vergleich -> IF1
;***************************************************

	MOVFW ZV1
	SUBWF ZV2,W	; F - W -> W

LABEL_IF1_CHECK
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS STATUS,ZERO	; Test auf -> =
	GOTO LABEL_IF1_FALSE

LABEL_IF1_TRUE
	BSF S2,0
	GOTO LABEL_IF1_EXIT

LABEL_IF1_FALSE
	BCF S2,0

LABEL_IF1_EXIT
;***************************************************
; ODER - Gatter -> LG7
;***************************************************

LABEL_LG7_1
	BTFSC S2,3
	GOTO LABEL_LG7_TRUE
LABEL_LG7_2
	BTFSC S1,6
	GOTO LABEL_LG7_TRUE

LABEL_LG7_FALSE
	BCF S1,7
	GOTO LABEL_LG7_ENDE
LABEL_LG7_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF S1,7
LABEL_LG7_ENDE
;***************************************************
; RS-FLIP-FLOP -> RS2
;***************************************************

	BTFSC S2,2
	GOTO LABEL_RS2_RESET
	BTFSS S2,1
	GOTO LABEL_RS2_ENDE
	BSF PORTB,7	; Ausgang setzen
	GOTO LABEL_RS2_ENDE
LABEL_RS2_RESET
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTB,7	; Ausgang zurcksetzen
LABEL_RS2_ENDE

;***************************************************
; One Shot -> OS4
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S2,0
	GOTO LABEL_OS4_1
	BTFSC OS4_FD,0
	GOTO LABEL_OS4_1
	BSF OS4_FD,0
	BSF S2,1
	GOTO LABEL_OS4_2
LABEL_OS4_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S2,1
	BTFSC S2,0
	GOTO LABEL_OS4_2
	BCF OS4_FD,0
LABEL_OS4_2
;***************************************************
; Timer -> TR5
;***************************************************

	MOVLW 7	; Test auf >=
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	SUBWF TR5_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR5_CHECK
	MOVLW 161
	SUBWF TR5,W	;F-W -> W
LABEL_TR5_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR5_ENDE

LABEL_TR5_RESET
	MOVLW 7	; Test auf >=
	SUBWF TR5_HI,F	;F-W -> F
	MOVLW 161
	SUBWF TR5,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR5_HI,F

LABEL_TR5_SET	; toggel output
	BTFSC PORTB,6
	GOTO LABEL_TR5_CLR
	BSF PORTB,6
	GOTO LABEL_TR5_ENDE
LABEL_TR5_CLR
	BCF PORTB,6
LABEL_TR5_ENDE

;***************************************************
; One Shot -> OS5
;***************************************************


	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS S2,0
	GOTO LABEL_OS5_1
	BTFSC OS5_FD,0
	GOTO LABEL_OS5_1
	BSF OS5_FD,0
	BSF S2,3
	GOTO LABEL_OS5_2
LABEL_OS5_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF S2,3
	BTFSC S2,0
	GOTO LABEL_OS5_2
	BCF OS5_FD,0
LABEL_OS5_2
;***************************************************
; ODER - Gatter -> LG8
;***************************************************

LABEL_LG8_1
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSC S1,2
	GOTO LABEL_LG8_TRUE
LABEL_LG8_2
	BTFSC S1,6
	GOTO LABEL_LG8_TRUE

LABEL_LG8_FALSE
	BCF S2,2
	GOTO LABEL_LG8_ENDE
LABEL_LG8_TRUE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BSF S2,2
LABEL_LG8_ENDE
;****************************************

	GOTO MAIN






TAB_LT3
	RETLW 80	; P
	RETLW 82	; R
	RETLW 69	; E
	RETLW 83	; S
	RETLW 69	; E
	RETLW 84	; T
	RETLW 0	; end


TAB_LT4
	RETLW 67	; C
	RETLW 79	; O
	RETLW 85	; U
	RETLW 78	; N
	RETLW 84	; T
	RETLW 69	; E
	RETLW 82	; R
	RETLW 0	; end


	END

